<?php include("bee/compiler.php"); return; ?>
<script language="bee">
include "common/firewall.bs";

function cachepage
{
	// Must not use PortalObjectName in 'begin'
	global PortalObjectName;
	global {PortalObjectName}%;

	global CachePageFormSubmit;
	global CachePageDirty;
	//global CachePageUpdated;
	//global CachePageStatus;
	global CachePageVar;
	global CachePageAction;

	result%function = "";  // Not cached (web page display continues after returning)

	if (!'{scheme%cachepage&Enabled}') return;  // Not enabled

	cmd = "{arg%arg|lowercase}";

	// File Path
	filepath = "{sys%urlshown:pathpage}";
	webpath = "{sys%croft:webpath}";
	if ('{webpath}' != '') filepath = "{filepath|replacere:^{webpath}}";
	filepath = "{filepath|replacere:^/+}";
	cachedir = "{scheme%cachepage&CacheDir:|default:cache}";
	cachevar = "CachePage{scheme%cachepage&CacheFace|precede:_}";

	cachePagePOPaths directoryindex = "{scheme%portal&DirectoryIndex:|default:index.htm}";
	//Subpath = "{result%cachePagePOPaths:Subpath}";
	TextSubdir = "{result%cachePagePOPaths:TextSubdir}";
	//PP = "{result%cachePagePOPaths:PP}";
	SP = "{result%cachePagePOPaths:SP}";

	access {
		switch ('{cmd}') {
		default:
		case 'begin':
			if ('{session%TextEdit:pagepath}' == '/{filepath}') {
				// Something has been updated
				if ('{session%TextEdit:pagecode}' == '{TextSubdir|replacere:^/+}{session%TextEdit:pagepath}') {
					// The update is on the page only
					//text%{TextSubdir}{SP}&{cachevar}:Dirty = 1;
					text%{TextSubdir}{SP}&CachePage:Updated = "{sys%time}";
				} else {
					// A common pagecode that affect all pages
					scheme%cachepage&AllCacheExpired = "{sys%time}";
				}
			}
			CachePageFormSubmit = "{sys%form:Submit}";
			// Do not touch session%TextEdit until the end - some appl may rely on it.
			break;
		case 'cancel':
		case 'end':
			// Now session%TextEdit may go.
			if ('{session%TextEdit:pagepath}' == '/{filepath}') {
				clear session%TextEdit;
			}
	
			// To handle Menu Edit, which will expire all cache
//display "PortalObjectName=[{PortalObjectName}]<br>\n";
			if ({#PortalObjectName:}) {
//display "%InApplication=[{{PortalObjectName}%InApplication}]<br>\n";
//display "%ApplicationInclude=[{{PortalObjectName}%ApplicationInclude}]<br>\n";
//display "CachePageFormSubmit=[{CachePageFormSubmit}]<br>\n";
				if ('{{PortalObjectName}%InApplication}'
				&& '{{PortalObjectName}%ApplicationInclude:|foundre:^portal.*/appl/menuedit.html?$}'
				&& '{#CachePageFormSubmit:}') {
					scheme%cachepage&AllCacheExpired = "{sys%time}";
				}
			}
			break;
		}
	}

	if ({#sys%form}) return;  // No cache for form submission



	// Determine whether to cache or not through the Firewall Rules

	// No need to go through firewall if CachePageAction is already determined (e.g. if cmd is "end")
	if ({#CachePageAction:} == 0) {
		varvalue = "(array)";
		varvalue:page = "{filepath}";
		varvalue:username = "{sys%auth:username}";
		varvalue:accesslevel = "{sys%auth:accesslevelname}";
	
		chkAppl = "{arg%checkappl:|default:1}";
		if ('{chkAppl}') {
			cachePageApplication;
			varvalue:appl = "{result%cachePageApplication}";
			varvalue:application = "{varvalue:appl}";  // In case the rule is specified as "application"
		}
//display "varvalue=[{varvalue|list}]<br>\n";
	
		//firewallScheme scheme="cachepage" ruleset="{sys%auth:accesslevelname}" default="CacheRule" varvalue="(var)varvalue" verbose="{arg%verbose}";
		firewallScheme scheme="cachepage" ruleset="CacheRule" varvalue="(var)varvalue" verbose="{arg%verbose}";
	
		CachePageAction = "{result%firewallScheme|lowercase}";
	}

	if ('{arg%verbose}') display "CachePageAction=[{CachePageAction}]<br>\n";
	if ('{CachePageAction}' != 'cache') return;  // No cache unless it is "cache"



	// Put it to session for global access and avoid re-entry from another web hit
	// if setting text%{TextSubdir}{SP}&{cachevar} direct.
	switch ('{cmd}') {
	default:
	case 'begin':
		//session%cachepage = (var)text%{TextSubdir}{SP}&{cachevar};
		//CachePageUpdated = "{text%{TextSubdir}{SP}&CachePage:Updated}";
		CachePageVar = (var)text%{TextSubdir}{SP}&{cachevar};

		//if ({#session%cachepage} == 0 || !'{session%cachepage:Enabled}') return;

		CachePageDirty = 0;  // Assume not dirty

		// Check AllCacheExpired
		if (!'{CachePageDirty}') {
			allCacheExpired = "{scheme%cachepage&AllCacheExpired}";
			if ('{allCacheExpired}' && '{CachePageVar:Cached|default:0}' <= '{allCacheExpired}') {
				//session%cachepage:Dirty = 1;
				CachePageDirty = 1;
			}
		}

		// Check page updated
		if (!'{CachePageDirty}') {
			if ('{CachePageVar:Cached|default:0}' <= '{text%{TextSubdir}{SP}&CachePage:Updated|default:0}') {
				CachePageDirty = 1;
			}
		}

		// Check face natural death
		if (!'{CachePageDirty}') {
			if ('{scheme%cachepage&TTL}' && '{CachePageVar:Expiry|default:0}' <= '{sys%time}') {
				CachePageDirty = 1;
			}
		}

		// Check cached content existence
		if (!'{CachePageDirty}') {
			cachedContent = "(var)file%{cachedir}/{filepath}&content";
			if ({#cachedContent:} == 0) {
				// No content
				CachePageDirty = 1;
			}
		}

		if ('{CachePageDirty}') {
			//CachePageStatus = 'refreshing';
			output;
		} else {
			// If CachePageDirty is fales, cachedContent must be loaded
			cachePageNoCache;
			display "(var)cachedContent";
			result%function = 1;  // Stop display after returning
		}
		break;
	case 'cancel':
	case 'end':
		if ('{CachePageDirty}') {
			//CachePageStatus = 'cached';
			CachePageVar:Cached = "{sys%time}";
			if ('{scheme%cachepage&TTL}') {
				CachePageVar:Expiry = "(expr){sys%time} + {scheme%cachepage&TTL}";
			}
			//session%cachepage:Dirty = 0;
			// Must not copy from CachePageVar to text%{TextSubdir}{SP}&{cachevar}
			// as CachePage:Updated might be overwritten if {cachevar} is "CachePage"
			//text%{TextSubdir}{SP}&{cachevar} = (var)CachePageVar;
			foreach (CachePageVar) text%{TextSubdir}{SP}&{cachevar}:{foreach:key} = "{foreach}";
			cachedContent = (var)sys%output:content;
			cachePageNoCache stuff="\n";
			file%{cachedir}/{filepath}&text = (var)cachedContent;
			file%{cachedir}/{filepath}&action:write = 0;
			output "{cmd}";
		}
//display "[{session%cachepage|list}]";
		break;
	}
}


function cachePageNoCache
{
	parent cachedContent;
	stuff = "{arg%stuff}";
	foreach (scheme%cachepage&NoCacheVar) {
		if ({#arg%stuff:} == 0) {
			global {foreach};
			stuff = "{{foreach}}";
		}
		cachedContent = (var)cachedContent conv="xreplacere:<!--nocachevar_begin:{foreach}-->.*<!--nocachevar_end:{foreach}-->,<!--nocachevar_begin:{foreach}-->{stuff|escape:commas}<!--nocachevar_end:{foreach}-->";
	}
}


function cachePagePOPaths
{
	Subpath = "";
	if ({#Subpath:} == 0) Subpath = "{scheme%portal&Subpath}";
	if ({#Subpath:} == 0) Subpath = "{sys%croft:webpath}";
	if ('{Subpath}' == '/') {
		Subpath = "";
	} else {
		Subpath = "{Subpath|replacere:^/+}";
		Subpath = "/{Subpath|replacere:/+$}";
	}

	TextSubdir = "";
	if ({#TextSubdir:} == 0) TextSubdir = "{scheme%portal&TextSubdir}";
	if ('{TextSubdir}' == '/') {
		TextSubdir = "";
	} else {
		TextSubdir = "{TextSubdir|replacere:^/+}";
		TextSubdir = "/{TextSubdir|replacere:/+$}";
	}

	PP = "";
	if ({#PP:} == 0) PP = "{sys%urlredirect:pathpage}";
	if ({#PP:} == 0) PP = "{sys%urlpart:pathpage}";
	if ({#PP:} == 0 || '{PP}' == '/') {
			PP = "/{arg%directoryindex}";
	}
	PP = "{PP|replacere:^/+}";
	PP = "/{PP|replacere:/+$}";

	SP = "{PP}";
	if ({#Subpath:}) SP = "{SP|replacere:^{Subpath}}";

	if ('{file%{sys%croft:textdir}{TextSubdir}{SP}&isdir}') {
			PP = "{PP}/{arg%directoryindex}";
			SP = "{SP}/{arg%directoryindex}";
	}

	result%function:Subpath = "{Subpath}";
	result%function:TextSubdir = "{TextSubdir}";
	result%function:PP = "{PP}";
	result%function:SP = "{SP}";
}

// This simulate the determination of InApplication in the Portal Object
// (As cachepage is involved before the PortalObject, so we cannot use its result.)
function cachePageApplication
{
	result%function = "";
	PortalObjectVersion = "{scheme%portal&PortalObjectVersion}";  // For variables in scheme%appl&
	//DirectoryIndex = "{scheme%portal&DirectoryIndex:|default:index.htm}";

	cachePagePOPaths directoryindex = "{scheme%portal&DirectoryIndex:|default:index.htm}";
	Subpath = "{result%cachePagePOPaths:Subpath}";
	TextSubdir = "{result%cachePagePOPaths:TextSubdir}";
	PP = "{result%cachePagePOPaths:PP}";
	SP = "{result%cachePagePOPaths:SP}";

	// The following is extracted from portal_prelude

	foreach (scheme%appl&PageMap) {
		if ({#foreach:} == 0) continue;
		if ('{SP|foundre:^/{foreach:key|replacere:^/+}}') {
			result%function = "{foreach}";
			return;
		}
	}

	foreach (scheme%appl&Prelude) {
		if ({#foreach:} == 0) continue;
		if ('{SP|foundre:^/{foreach:key|replacere:^/+}}') {
			result%function = "{foreach}";
			return;
		}
	}

	foreach (scheme%appl&Application) {
		if ({#foreach:} == 0) continue;
		applSP = "/{foreach:key|replacere:^/+}";  // Normalise to one '/' in front
		if ('{SP|foundre:^{applSP}}') {
			result%function = "{foreach}";
			return;
		}
	}

	applHTM = "{sys%croft:WWWDir}/appl{SP}";
	if ('{file%{applHTM}&exists}') {
		result%function = "{this%IncludeRoot}appl{SP}";
		return;
	}

	if (!'{SP|foundre:\.html?$|\.bee$|\.bs$|\.php.?$|\.aspx?$}') exit;

	spBS = "{SP}";
	spBS = "{spBS|replacere:html?$,bs}";
	applBS = "{sys%croft:WWWDir}/appl{spBS}";
	if ('{file%{applBS}&exists}') {
		result%function = "{this%IncludeRoot}appl{spBS}";
		return;
	}
}
</script>
