<?php include("bee/compiler.php"); return; ?>
<script language="bee">

/************************************************************
 *	keyvalue = The search key value
 *	keyname = The search key name (Ignore if keyvalue is non-null)
 *	itemname = The item name (default to be "Article")
 *	headname = The name of the item where the content is used as item headline.
 *	headmsg = The header of the search page (without the cont'd part)
 *	nokeymsg = The message if there's no key entered
 *	footmsg = The footline of the search page
 *	rpp = Number of search records per page (default 5)
 *	ppb = Number of search pages per block/bar (default 10)
 ************************************************************/

function sitesearch
	keyvalue=""
	keyname="key"
	itemname="Article"
	headname="title"
	headmsg="Searching for <b><i>?</i></b>"
	nokeymsg="Please enter a search key and click &quot;Go&quot;"
	footmsg="End of page"
	maxitemlen="300"
	rpp="5"
	ppb="10"
	ignored=""
{
/*
	If {keyvalue} is blank, take {sys%form:{keyname}}
	If still blank
		take from {session%search:{keyname}}
		if non-blank
			get {sys%form:record} and display smaller header + cont'd
	else
		save into the session and set record to 1
		display big header
 */

//display "DEBUG:Search<br>\n";
	var keyvalue = {arg%keyvalue};
	
	if ('{keyvalue}' == '')
		var keyvalue = {sys%form:{arg%keyname}};
	
	if ('{keyvalue}' == '')
	{
		var keyvalue = {session%search:{arg%keyname}};
		if ('{keyvalue}' != '')
		{
			var record = {sys%form:record};
			display "<h4>{arg%headmsg|replace:?,{keyvalue}} (cont'd)</h4>\n";
		}
	} else
	{
		var session%search:{arg%keyname} = {keyvalue};
		var record = 1;
		display "<h3>{arg%headmsg|replace:?,{keyvalue}}</h3>\n";
	}
	
	
	if ('{keyvalue}' == '')
	{
		display "<h3>{arg%nokeymsg}</h3>\n";
	} else
	{
		database search action="new";  // VirtualBase "search"
//display 'DEBUG:After "new" status%database:search=[{status%database:search}]<br>\n';
		//var srchList = {keyvalue} convert=split;
		//var srchList = (var)srchList convert="replace:+,' '";
		var srchList = "(array)\ {keyvalue|unescape}";
//display 'DEBUG:srchList=[{srchList|list}]<br>\n';
	
		var ignoredList = "(array){arg%ignored}";
		var afterIgnoreText = "";
		foreach (ignoredList)
		{
			var ignoredKey = {srchList|search:{foreach}};
			if ('{ignoredKey}')
			{
				clear srchList:{ignoredKey};
				display '<font size=-1>"<b>{foreach}</b>" is ignored as it is a common word or phrase.</font><br>\n';
				var afterIgnoreText = "<br>";
			}
		}
		display "{afterIgnoreText}";
	
		// Build the search list
	
		foreach (sys%textpagelist as page)
		{
//display 'DEBUG:Check page {page}<br>\n';
			foreach (text%{page}& as text)
			{
				if ('{text|foundre:^[A-Z]}' || '{text}' == '{arg%headname}')
					continue;
//display ' &nbsp; text {text}\n';
				access {scheme%{text}:Allow}
				{
//display 'Allowed\n';
					var stripped = {text%{page}&{text}|htmlstrip};
					var hits = 0;
//display '[{srchList|list}]\n';
					foreach (srchList as srchKey)
					{
//display '{srchKey}?\n';
						var hits = "(expr){hits} + {stripped|countstric:{srchKey}}";
					}
					if ({hits} > 0)
					{
//display 'Hit\n';
						var stripped = {stripped|truncate:{arg%maxitemlen},...};
						database search query="
insert into search ( URL, Title, Text, TextName, Hits ) values ( '{sys%url:server}/{page}', '{text%{page}&{arg%headname}}', '{stripped|escape:quotes}', '{text}', '{hits}' )";
					}
				}
//display '<br>\n';
			}
//display '<br>\n';
		}
	
	
		// Display the search result

		clear search%pagebar;
		var href = 'href="{sys%url:page}?record=@record"';
		var search%pagebar:back = "<a {href}>&lt;&lt;</a>";	
		var search%pagebar:page = "<a {href}>@page</a>";	
		var search%pagebar:sought = "<b>@page</b>";	
		var search%pagebar:forward = "<a {href}>&gt;&gt;</a>";

		database search query="select URL, Title, Text, TextName, Hits from search order by Hits desc, ID" seek="{record},{arg%rpp},{arg%ppb}";
//display 'DEBUG:After "select" status%database:search=[{status%database:search}]<br>\n';

		if ('{search%numrecs}' == 0)
		{
			display '<h4>{search%last:record|plural:{arg%itemname}} were found</h4>\n';
		} else
		{
			if ('{search%first:rip}' == 1 && '{search%last:rip}' == '{search%last:record}')
			{
				display 'All ${search%last:record|plural:{arg%itemname}} found are listed:\n';
			} else
			{
				// This block is duplicated in this page
				// Display the statistics
				display '{arg%itemname} {search%first:rip} to {search%last:rip} &nbsp;\n';
				display '({search%count:rip} out of {search%last:record}) &nbsp;\n';
				display 'Page {search%sought:page} of {search%last:page} &nbsp;\n';
				display "{search%page|list:(@value)\n&nbsp;\n()}";
				/*
				foreach (search%page as page)
				{
					if ('{search%sought:page}' == '{page:key}')
						display '<b>{page:key}</b>\n';
					else
						display '<a href="{sys%url:page}?record={page}">{page:key}</a>\n';
	
					display '&nbsp;\n';
				}
				 */
			}
	
			display '<hr>\n';
	
			foreach maxiterations={arg%rpp} ((db)search as rec)
			{
</script>

	<table width="100%" cellspacing="0" cellpadding="0">
		<tr valign="top">
			<td> <b><a href="${rec:URL}">${rec:Title}</a></b>
			<font size="-1">(${rec:Hits|plural:match})</font>
			&nbsp; &nbsp;
			<i><a href="${rec:URL}#${rec:TextName}">${rec:URL|replacere:/index\.htm$,/}</a></i></td>
		</tr>
		<tr>
			<td>[bee var=rec:Text convert='highlight:<font color=#ffffff style="background-color: #000000">,</font>,{srchList|list:(@value),()}' display=1]</td>
		</tr>
	</table>
			
<hr>
<script language="bee">
			}
		}
	
		if ('{search%numrecs}' > 0)
		{
			// This block is duplicated in this page
			// Display the statistics
			display '{arg%itemname} {search%first:rip} to {search%last:rip} &nbsp;\n';
			display '({search%count:rip} out of {search%last:record}) &nbsp;\n';
			display 'Page {search%sought:page} of {search%last:page} &nbsp;\n';
			display "{search%page|list:(@value)\n&nbsp;\n()}";
			/*
			foreach (search%page as page)
			{
				if ('{search%sought:page}' == '{page:key}')
					display '<b>{page:key}</b>\n';
				else
					display '<a href="{sys%url:page}?record={page}">{page:key}</a>\n';
	
				display '&nbsp;\n';
			}
			 */
		}
	
		display '<center><p><font size="+1"><b>{arg%footmsg}</b></font></p></center>\n';
	}
}
</script>
