<?php include("bee/compiler.php"); return; ?>
<script language="bee">

/************************************************************
 *	tree_add...
 *	arg%node - Node index to add
 *	arg%to - Node to add to (default is this%current)
 ************************************************************/

function tree_addchild
{
	// Allow blank node
	var node = "{arg%node}";
	if ({arg%function:node|isset} == 0) return status=1 message="Argument 'node' is missing";

	var to = "{arg%to}";
	if ({arg%function:to|isset} == 0) var to = "{this%current}";
	if ({this%parent:{to}|isset} == 0 && '{to}' != '{this%root}')
		return status=2 message="Cannot add to a non-existing node '{to}'";

	if ('{node}' == '{to}')
		return status=4 message="Cannot add to the node '{to}' itself";

	this%tree_isolatenode node="{node}";
	var this%parent:{node} = "{to}";
	this%tree_insertelement node="{node}" list="(var)this%child_{to}" pos=0;
	if ({status%tree_insertelement})
		return status="{status%tree_insertelement}" message="{message%tree_insert_element}";
	var this%child_{to} = "(var)result%tree_insertelement";
}


function tree_addelder
{
	// Allow blank node
	var node = "{arg%node}";
	if ({arg%function:node|isset} == 0) return status=1 message="Argument 'node' is missing";

	var to = "{arg%to}";
	if ({arg%function:to|isset} == 0) var to = "{this%current}";
	if ({this%parent:{to}|isset} == 0 && '{to}' != '{this%root}')
		return status=2 message="Cannot add to a non-existing node '{to}'";
	if ('{to}' == '{this%root}')
		return status=3 message="Cannot add an 'elder' node to root '{to}'";

	if ('{node}' == '{to}')
		return status=4 message="Cannot add to the node '{to}' itself";

	this%tree_isolatenode node="{node}";
	this%tree_siblings node="{to}";
	var siblings = "(var)result%tree_siblings";
	if ({#siblings} == 0) return status=5 message="Cannot add an 'elder' node to '{to}'";

	var pos = "{siblings|valuepos:{to}}";
	this%tree_insertelement node="{node}" list="(var)siblings" pos="{pos}";
	if ({status%tree_insertelement})
		return status="{status%tree_insertelement}" message="{message%tree_insert_element}";
	// this%parent:{to} must be set by now
	var this%child_{this%parent:{to}} = "(var)result%tree_insertelement";
}


function tree_addyounger
{
	// Allow blank node
	var node = "{arg%node}";
	if ({arg%function:node|isset} == 0) return status=1 message="Argument 'node' is missing";

	var to = "{arg%to}";
	if ({arg%function:to|isset} == 0) var to = "{this%current}";
	if ({this%parent:{to}|isset} == 0 && '{to}' != '{this%root}')
		return status=2 message="Cannot add to a non-existing node '{to}'";
	if ('{to}' == '{this%root}')
		return status=3 message="Cannot add a 'younger' node to root '{to}'";

	if ('{node}' == '{to}')
		return status=4 message="Cannot add to the node '{to}' itself";

	this%tree_isolatenode node="{node}";
	this%tree_siblings node="{to}";
	var siblings = "(var)result%tree_siblings";
	if ({#siblings} == 0) return status=5 message="Cannot add an 'younger' node to '{to}'";

	var pos = "{siblings|valuepos:{to}}" conv="inc";
	this%tree_insertelement node="{node}" list="(var)siblings" pos="{pos}";
	if ({status%tree_insertelement})
		return status="{status%tree_insertelement}" message="{message%tree_insert_element}";
	// this%parent:{to} must be set by now
	var this%child_{this%parent:{to}} = "(var)result%tree_insertelement";
}


// Insert {arg%node} into {arg%list} at position {arg%pos}
function tree_insertelement
{
	if ({arg%function:node|isset} == 0) return status=1 message="Argument 'node' is missing";
	if ({arg%function:pos|isset} == 0 || {#arg%function:pos} == 0)
		return status=2 message="Argument 'pos' is missing";

	var node = "{arg%node}";
	var list = "(var)arg%list";
	var pos = "{arg%pos}";
	
	if ({pos} < 0) {
		var pos = 0;
		var status%function = 3;
		var message%function = "Argument 'pos' is negative (assumed 0)";
	} else if ({pos} > {#list}) {
		var pos = "{#list}";
		var status%function = 4;
		var message%function = "Argument 'pos' is after the end of list (assumed {#list})";
	}
	
	var result%function = "(var)list";
	
	if ({pos} <= 0) {
		var result%function conv="unshift:{node}";
	} else if ({pos} >= {#list}) {
		var result%function conv="push:{node}";
	} else {
		var result%function = "(var)list" conv="slice:0,{pos}";
		var result%function conv="push:{node}";
		var tail = "(var)list" conv="slice:{pos}";
		var result%function = "(var)result%function" conv="merge:(var)tail";
	}
}
</script>
