<html>
<head>
<title>Working BEE 1.0</title>
<style type="text/css">
<!--
body {  background-color: #FFFFCC; font-family: Arial; font-size: 12px; color: #000000; }
.error {  font-size: 12px; font-weight: bold; color: #FF0000; }
.warning {  font-size: 12px; color: #FF0000; }
.advice {  font-size: 12px; font-weight: bold; color: #000000; }
-->
</style>
</head>
<body leftmargin="100" rightmargin="100">
<center>
<a href="http://www.onmyweb.net/bee/workingbee/userguide.htm" target=_blank><img src="images/WorkingBEE.gif" border=0></a><br><br>
</center>

<?php printf("<!" . "--\n"); ?>

<p class="error">ERROR: Your web server does not support PHP.</p>
<p>
Working BEE 1.0 requires PHP 4.3.3 or above to run.
</p>
<p class="advice">
Please install Working BEE 1.0 on a PHP enabled web server and try again.<br>
You may download PHP from <a href="http://www.php.net/downloads.php">http://www.php.net/downloads.php</a>.
</p>

<?php printf("--" . ">\n"); ?>

<!--
<?php printf("--" . ">\n"); ?>


<?php
// Initialization
$product = "Working BEE 1.0";

$abort = 0;
$minPHPVer = "4.3.3";
$minZOVer = "2.6.0";
?>


<?php
// Check PHP Version
//if ($abort == 0) {
	$phpVer = phpversion();
	if (version_compare($phpVer, $minPHPVer) < 0) {
		$abort = 1;
?>

<p class="error">ERROR: Your web server is running PHP <?php echo $phpVer; ?>.</p>
<p>
<?php echo $product; ?> requires PHP <?php echo $minPHPVer; ?> or above to run.
</p>
<p class="advice">
Please upgrade your PHP to at least version <?php echo $minPHPVer; ?> and try again.<br>
You may download PHP from <a href="http://www.php.net/downloads.php">http://www.php.net/downloads.php</a>.
</p>

<?php
	}
//}
?>


<?php
// Check Zend Optimizer

//if ($abort == 0) {
	if (!extension_loaded('Zend Optimizer')) {
		$abort = 1;
?>

<p class="error">ERROR: Zend Optimizer is not loaded in your PHP.</p>
<p>
<?php echo $product; ?> requires Zend Optimizer <?php echo $minZOVer; ?> or above to run.
</p>
<p class="advice">
Please install Zend Optimizer <?php echo $minZOVer; ?> or above and try again.<br>
You may download Zend Optimizer from <a href="http://downloads.zend.com/optimizer/3.0.0/">http://downloads.zend.com/optimizer/3.0.0/</a>.
</p>

<?php
	} else {
		// Check Zend Optimizer Version

		ob_start();
		phpinfo();
		$zoVer = ob_get_contents();
		ob_end_clean();
		$zoVer = ereg_replace('.*Zend( |&nbsp;)Optimizer( |&nbsp;)v', '', $zoVer);
		$zoVer = ereg_replace('[^0-9\.].*', '', $zoVer);
		if (version_compare($zoVer, $minZOVer) < 0) {
			$abort = 1;
?>

<p class="error">ERROR: Your PHP is loaded with Zend Optimizer <?php echo $zoVer; ?>.</p>
<p>
<?php echo $product; ?> requires Zend Optimizer <?php echo $minZOVer; ?> or above to run.
</p>
<p class="advice">
Please upgrade your Zend Optimizer to at least version <?php echo $minZOVer; ?> and try again.
You may download Zend Optimizer from <a href="http://downloads.zend.com/optimizer/3.0.0/">http://downloads.zend.com/optimizer/3.0.0/</a>.
</p>

<?php
		}
	}
//}
?>


<?php
?>


<?php
// Check directory access

//if ($abort == 0) {
	$BEEDir = dirname($_SERVER["SCRIPT_FILENAME"]);
	$testFile = "test_" . time() . ".txt";

	$typeList = array('obj' => 'error', 'scheme' => 'error', 'cust' => 'warning', 'vb' => 'warning');

	$adviceList = array(
		'obj' => 'BEE would not be able to compile and run.',
		'scheme' => 'BEE would not be able to save web content.',
		'cust' => 'BEE would not be able to insert images to web content.',
		'vb' => 'BEE would not be able to store dynamic navigation menu.');

	$count_error = 0;
	$count_warning = 0;

	foreach ($typeList as $subdir => $tp) {
		$fn = $BEEDir . '/' . $subdir . '/' . $testFile;
		$fd = @fopen($fn, "w");
		if ($fd) {
			fclose($fd);
			unlink($fn);
		} else {
			${"count_" . $tp} += 1;
?>
<p>
<span class="<?php echo $typeList[$subdir]; ?>">
<?php echo strtoupper($typeList[$subdir]); ?>:
The web server cannot write to <?php echo dirname($fn); ?>.<br>
</span>
<?php echo $adviceList[$subdir]; ?>
</p>
<?php
		}
	}

	if ($count_error) {
		$abort = 1;
?>
<p class="advice">Please grant the web server user "write" access to the above directories and all files and subdirectories under them, then try again.</p>
<?php
} else if ($count_warning) {
?>
<p class="advice">If you want to use such BEE features, please grant the web server user "write" access to the above directories and all files and subdirectories under them.</p>
<?php
	}
//}
?>



<?php
if ($abort == 0) {
?>

<script language="JavaScript">
window.location = "./login.php";
</script>

<?php
}
?>



<?php printf("<!" . "--\n"); ?>
-->

<center>
<p>&nbsp;</p>

<a href="http://www.onmyweb.net/bee/workingbee/userguide.htm" target=_blank>Working BEE User Guide</a>
</center>

</body>
</html>
