<?php include("bee/compiler.php"); return; ?>
<script language="bee">

/************************************************************
 *	Structure
 ************************************************************/

/************************************************************
 *	Multiple nodes:  These functions do not move the tail (path end)
 *		or change any object variables
 ************************************************************/

/************************************************************
 *	tree_children: Return an array containing the indexes of all children node
 *
 *	arg%node = the node of which the children are returned (default current node)
 *	result%function = the array of indexes of all children node
 ************************************************************/

function tree_children
{
	// Allow blank node
	var node = "{arg%node}";
	if ({arg%function:node|isset} == 0) var node = "{this%current}";

	if ({this%child_{node}|isset}) var result%function = "(var)this%child_{node}";
/*
	this%tree_child node="{node}";
	if ({status%tree_child}) return;  // No error, just no children

	this%tree_siblings node="{result%tree_child}";
	var result%function = "(var)result%tree_siblings";
	return status="{status%tree_siblings}" message="{message%tree_siblings}";
 */
}


/************************************************************
 *	tree_siblings: Return an array containing the indexes of all siblings node
 *		including itself
 *
 *	arg%node = the node of which the siblings are returned (default current node)
 *	result%function = the array of indexes of all siblings node
 ************************************************************/

function tree_siblings
{
	// Allow blank node
	var node = "{arg%node}";
	if ({arg%function:node|isset} == 0) var node = "{this%current}";

	if ({this%parent:{node}|isset}) {
		this%tree_children node="{this%parent:{node}}";
		if ({status%tree_children} == 0 && {#result%tree_children})
			var result%function = "(var)result%tree_children";
	}

/*
	var result%function conv="push:{node}";  // Get itself

	// Get elders
	var sibling = "{node}";
	while (1) {
		this%tree_elder node="{sibling}";
		//if ({status%tree_elder}) return status="{status%tree_elder}" message="{message%tree_eldere}";
		if ({result%tree_elder:count} == 0) break;
		var sibling = "{result%tree_elder}";
		//if ({#sibling:} == 0) break;
		var result%function conv="unshift:{sibling}";
	}

	// Get youngers
	var sibling = "{node}";
	while (1) {
		this%tree_younger node="{sibling}";
		//if ({status%tree_younger}) return status="{status%tree_younger}" message="{message%tree_youngere}";
		if ({result%tree_younger:count} == 0) break;
		var sibling = "{result%tree_younger}";
		//if ({#sibling:} == 0) break;
		var result%function conv="push:{sibling}";
	}
 */
}


// Get the indexes of all nodes under a node including itself,
//	depth-first (recursively)
// arg%node - the root of the subtree (compulsory)
// result%function - all nodes in depth-first order
function tree_descendants
{
	// Allow blank node
	if ({arg%function:node|isset} == 0) return status=1 message="Argument 'node' is missing";

	var result%function conv="push:{arg%node}";
	this%tree_children node="{arg%node}";
	foreach (result%tree_children) {
		this%tree_descendants node="{foreach}";
		var result%function = "(var)result%function" conv="merge:(var)result%tree_descendants";
	}
}


function tree_getroot
{
	var result%function = "{this%root}";
}


function tree_getallnodes
{
	var result%function = "(var)this%parent" conv="keys";
	if ({this%root|isset}) var result%function conv="unshift:{this%root}";
}
</script>
