<?php include("bee/compiler.php"); return; ?>
<script language="bee">

/************************************************************
 *	xml_dump: Display the XML object
 *
 *	arg%node - a subtree to be dump (Default {this%root})
 ************************************************************/

function xml_dump
{
</script>
<table border=1>
  <tr bgcolor="#666666">
	<td><font color="#FFFFFF"><b>Node</b></font></td>
	<td><font color="#FFFFFF"><b>Tag</b></font></td>
	<td><font color="#FFFFFF"><b>Type</b></font></td>
	<td rowspan=2><font color="#FFFFFF"><b>Value</b></font></td>
	<td rowspan=2><font color="#FFFFFF"><b>Prefix</b></font></td>
	<td rowspan=2><font color="#FFFFFF"><b>Local Part</b></font></td>
	<td rowspan=2><font color="#FFFFFF"><b>Namespace</b></font></td>
  </tr>
  <tr bgcolor="#333333">
	<td colspan=3 align=right><font color="#FFFFFF"><b>Attribute</b></font></td>
  </tr>
<script language="bee">
	var node = "{arg%node}";
	if ({arg%function:node|isset} == 0) var node = "{this%root}";
	this%xml_dumpsubtree node="{node}" level=-1;
</script>
</table>
<script language="bee">
}

function xml_dumpsubtree
{
	if ({arg%function:node|isset} == 0) return status=1 message="Argument 'node' is missing";
	var node = "{arg%node}";

	var level = "{arg%level}";
	if ({#arg%function:level} == 0) var level=-1;

	this%xml_getnode node="{node}";
	if ({status%xml_getnode}) {
		display "Cannot get node '{node}' ({message%xml_getnode})";
		return;
	}

	// Don't quit ... for the sake of the children!  (sob ...)
	if ({#result%xml_getnode}) {
		var indent = '';
		if ({level} > 0) var indent = "{this%indent}" conv="repeat:{level}";
	
		var tagbg = "#CCCCCC";
		var attrbg = "#CCCCCC";
		var fontOpen = "";
		var fontClose = "";
		var tagLead = "";
		var tagTrail = "";
	
		switch ('{result%xml_getnode:type}') {
		case 'open':
			var tagbg = "#FFFF99";
			var attrbg = "#FFFFFF";
			break;
		case 'complete':
			var tagbg = "#FFFFCC";
			var attrbg = "#FFFFFF";
			break;
		case 'cdata':
			var tagLead = "(";
			var tagTrail = ")";
			var tagbg = "#999999";
			var attrbg = "#FFFFFF";
			break;
		case 'close':
			var fontOpen = "<font color=#CCCCCC>";
			var fontClose = "</font>";
			var tagLead = "/";
			var tagbg = "#FFFFFF";
			var attrbg = "#FFFFFF";
			break;
		}
	
</script>
  <tr bgcolor="${tagbg}" valign="top">
	<td>${node}</td>
	<td>${indent}${fontOpen}<b>${tagLead}${result%xml_getnode:tag}${tagTrail}</b>${fontClose}</td>
	<td>${fontOpen}<font size=-1>${result%xml_getnode:type}</font>${fontClose}</td>
	<td>${fontOpen}${result%xml_getnode:value}${fontClose}</td>
	<td>${fontOpen}${result%xml_getnode:prefix}${fontClose}</td>
	<td>${fontOpen}${result%xml_getnode:localpart}${fontClose}</td>
	<td>${fontOpen}${result%xml_getnode:namespace}${fontClose}</td>
  </tr>
<script language="bee">
		this%xml_getattrlist node="{node}";
		foreach (result%xml_getattrlist as attr) {
			this%xml_getattr node="{node}" attr="{attr}";
			if ({status%xml_getattr}) {
				display "Cannot get attribute '{attr}' of node '{node}' ({message%xml_getattr})";
				continue;
			}
</script>
  <tr bgcolor="${attrbg}" valign="top">
	<td colspan=3 align=right><b><i>${attr}</i></b></td>
	<td>${result%xml_getattr:value}</td>
	<td>${result%xml_getattr:prefix}</td>
	<td>${result%xml_getattr:localpart}</td>
	<td>${result%xml_getattr:namespace}</td>
  </tr>
<script language="bee">
		}
	}

	// Dump children now
	var nextLevel = "{level|inc}";
	this%tree_children node="{node}";
	foreach (result%tree_children) this%xml_dumpsubtree node="{foreach}" level="{nextLevel}";
}
</script>
